=== debian/changelog ===
fio (2.2.10-1ubuntu1~ubuntu14.04.1) trusty-backports; urgency=medium

  * No-change backport to trusty (LP: #155685)

 -- Iain Lane <iain@orangesquash.org.uk>  Mon, 21 Mar 2016 09:28:01 +0000

fio (2.2.10-1ubuntu1) xenial; urgency=medium

  * debian/patches/fix-ftbfs-with-libmtd.h: Grab patch from Debian to fix
    FTBFS due to unknown type names.

 -- Logan Rosen <logan@ubuntu.com>  Thu, 17 Mar 2016 22:45:29 -0500

fio (2.2.10-1) unstable; urgency=medium

  * Imported Upstream version 2.2.10 (Closes: #803991).
    * Fixes fio: calc_clat_percentiles() create unaligned access on armhf.
      (Closes: #779336). Thanks to Andreas Bießmann.
    * Fixes ssd-test 1g file size too small (Closes: #776701). Thanks to
      Daniel Pocock.
  * patches:
    * Removed makefile patches as makefile is now generated via autoconf.
    * configure-no-configlog: Remove config.log at end of configure process
      to avoid error about uncommitted change from dpkg-source.
  * rules:
    * Switched to dh_$@ wildcard version of rules file.
    * Added override for dh_auto_configure cause upstream configure file
      does not understand many options dh_auto_configure passed to it.
    * Enabled build of graphical fio frontend gfio.
    * Made sure that is only links in needed libraries for gfio to avoid
      unnecessary dependencies.
  * control:
    * Updated to standards version 3.9.6. No changes needed.
    * Point to github page as new homepage as it appears to be closest to a
      homepage of any of the URLs mentioned in the README.
    * Added new binary package gfio for graphical frontend of fio.
    * Mentioned relationship between fio and gfio in package descriptions
      and added suggests for each other.
  * copyright:
    * Fixed lintian messages about changed/wrong paths to
      referenced files.
    * Reviewed and updated by rechecking against all source files.
  * Switched to debhelper 9 in order to have dpkg-buildflags and thus
    hardening by default.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Tue, 10 Nov 2015 10:00:35 +0100
