=== debian/control ===
Source: fio
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Martin Steigerwald <martin.steigerwald@teamix.de>
Uploaders: Michael Prokop <mika@debian.org>
Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev, librbd-dev, libgtk2.0-dev, libcairo2-dev
Standards-Version: 3.9.6
Homepage: https://github.com/axboe/fio
Vcs-Git: git://anonscm.debian.org/collab-maint/fio.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/fio.git

Package: fio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python
Suggests: gnuplot, gfio
Description: flexible I/O tester
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the command line version of fio and all additional
 command line tools. The package gfio contains the GTK+ based gui frontend
 for fio.

Package: gfio
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: fio
Description: flexible I/O tester - gui frontend
 fio is a tool that will spawn a number of threads or processes doing a
 particular type of I/O action as specified by the user. fio takes a
 number of global parameters, each inherited by the thread unless
 otherwise parameters given to them overriding that setting is given.
 The typical use of fio is to write a job file matching the I/O load
 one wants to simulate.
 .
 This package contains the GTK+ based gui frontend for fio. The package
 fio contains the command line version of fio which acts as a backend
 to the GUI frontend. The frontend can talk to a locally or remotely
 running fio server.
