## fio 2.10

=== debian/changelog ===
fio (2.10-2) unstable; urgency=medium

  * copyright: Added fiologparser.py copyrights as per git blame.
  * control: Added python-scipy as suggests for fiologparser.py.
  * control: Removed Sven Hoexter as uploader again as per his request.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Tue, 24 May 2016 12:33:25 +0200

fio (2.10-1) unstable; urgency=medium

  * Imported Upstream version 2.10.
  * patches: Refreshed, no manual changes needed.
  * debian/rules: Enabled using the "bindnow" linker flag to disable more
    insecure late binding.
  * docs: Added file tools/fiologparser.py.
  * Imported Upstream version 2.9.
  * patches: Refreshed, no manual changes needed.
  * control:
    * Upgraded to standards version 3.9.8.0, no changes needed.
    * Removed Michael Prokop as uploader as per his request. Thanks
      for sponsoring the package initially.
    * Added Sven Hoexter as uploader as he sponsored the last versions.
  * docs: Add file MORAL-LICENSE.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Mon, 23 May 2016 16:28:16 +0200

fio (2.6-1) unstable; urgency=medium

  * Imported Upstream version 2.6.
  * patches/fix-ftbfs-with-libmtd.h: Fix FTBFS: libmtd.h:288:8: error:
    unknown type name 'uint8_t'. Thanks Chris. (Closes: #815735)
  * control:
    - Updated to standards version 3.9.7. No changes needed.
    - Made Vcs-Browser and Vcs-Git URLs secure 
  - copyright:
    - Adapted path for library files that are now in oslib.
    - fio.1: Fixed license to GPL-2. Don´t know how I came to the
      conclusion that it would be GPL-2+, if the rest without any
      license specified is GPL-2.
    - rate_submit.c: Added copyright.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Wed, 24 Feb 2016 10:47:40 +0100
