=== debian/changelog ===
fio (2.16-1) unstable; urgency=medium

  * Imported upstream version 2.16.
  * debian/patches: Refreshed.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Fri, 23 Dec 2016 17:09:43 +0100

fio (2.15-1) unstable; urgency=medium

  * Imported upstream version 2.15.
  * debian/patches:
    - Refreshed.
    - spelling-errors: Fix some spelling errors in HOWTO, fio binary
      and manpage.
    - reproducible-build: Sort object files for deterministic linking order
      to enable reproducible builds. Thank to Rainer Herrmann for the bug
      report and patch (Closes: #828791).
  * debian/watch: Check for GPG signature of upstream tarball.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Mon, 19 Dec 2016 16:02:52 +0100
