=== debian/control ===
--- 
+++ 
@@ -1,19 +1,17 @@
 Source: fio
 Section: utils
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Martin Steigerwald <martin.steigerwald@teamix.de>
-Uploaders: Michael Prokop <mika@debian.org>
+Maintainer: Martin Steigerwald <martin.steigerwald@teamix.de>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev, librbd-dev, libgtk2.0-dev, libcairo2-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: https://github.com/axboe/fio
-Vcs-Git: git://anonscm.debian.org/collab-maint/fio.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/fio.git
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/fio.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/fio.git
 
 Package: fio
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, python
-Suggests: gnuplot, gfio
+Suggests: gnuplot, gfio, python-scipy
 Description: flexible I/O tester
  fio is a tool that will spawn a number of threads or processes doing a
  particular type of I/O action as specified by the user. fio takes a
