=== debian/watch ===
version=4
opts="pgpmode=next" http://brick.kernel.dk/snaps/fio-(\d.*)\.tar\.gz
opts="pgpmode=previous" http://brick.kernel.dk/snaps/fio-(\d.*)\.tar\.gz\.asc
