=== debian/changelog ===
fio (3.1-1) unstable; urgency=medium

  * Imported upstream versions 3.0 and 3.1 (Closes: #869686).
  * Adapted my mail address to new company domain.
  * patches:
    - Refreshed.
    - Dropped patch spelling-errors. Applied upstream.
    - Changed author in all of my patches to new mail address.
  * control: Bumped standards version to 4.1.1.0.
    * watch: Changed to pgpsigurlmangle as recommended by policy 4.1.0.0,
      section 4.11.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 24 Oct 2017 09:47:45 +0200

fio (2.17-1) unstable; urgency=medium

  * Imported upstream version 2.17.
  * debian/patches: Refreshed.
  * debian/copyright: Updated, added some files, all GPL-2.
  * debian/docs: Added fio_latency2csv.py, example systemd fio.service file, and
    logparser histogram scripts from tools/hist.

 -- Martin Steigerwald <martin.steigerwald@teamix.de>  Mon, 23 Jan 2017 11:10:42 +0100
