=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: fio
 Section: utils
 Priority: optional
-Maintainer: Martin Steigerwald <martin.steigerwald@teamix.de>
+Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
 Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev, librbd-dev, libgtk2.0-dev, libcairo2-dev
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1.0
 Homepage: https://github.com/axboe/fio
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/fio.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/fio.git
