## fio 3.8

=== debian/changelog ===
fio (3.8-1) unstable; urgency=medium

  * Imported upstream version 3.8.
  * rules: Use '--disable-native' to disable build system local CPU
    optimizations (Closes: #898473). Thank you, Sitsofe.
  * control: Bumped standards version to 4.2.0, no changes needed.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 21 Aug 2018 16:19:28 +0200

fio (3.6-4) unstable; urgency=medium

  * Contrary to what I stated in 3.5-1 changelog entry libnuma1-dev appears
    to be available in buster/sid. As it is only available for Linux platforms
    restrict the build dependency to those instead.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 16 May 2018 11:24:41 +0200

fio (3.6-3) unstable; urgency=medium

  * control: Also build libibverbs-dev only on Linux platforms as it is only
    available for those.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 15 May 2018 14:04:56 +0200

fio (3.6-2) unstable; urgency=medium

  * control: Build with librdmacm-dev and librbd-dev only on Linux platforms as
    they are only available for those.

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Tue, 15 May 2018 10:21:30 +0200

fio (3.6-1) unstable; urgency=medium

  * Imported upstream version 3.6.
  * patches: Refreshed.
  * control: Build with libaio-dev only on Linux platforms instead of all
    other platforms than Linux. Thanks for Sven Hoexter for finding the
    mistake in the build depends. Thanks Hillel Lubman for the report
    (Closes: #898210).

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Wed, 09 May 2018 08:55:08 +0200

fio (3.5-1) unstable; urgency=medium

  * Imported upstream version 3.5.
  * Install systemd service file for running fio as a service, disabled
    by default (also see #893778).
  * Install sysvinit script for running fio as a service, disabled by
    default. Thanks to KatolaZ from Devuan project for helpful hint.
    Does not install any symlinks currently (see #894084).
  * patches:
    - Refreshed.
    - fix-ftbfs-with-libmtd.h: Removed. Implemented upstream (also see
    #893778).
    - makefile-hardening: Allow adding hardening options to CPPFLAGS as
      well.
    - reproducible-build: Removed. Implemented upstream (also see #893778
      and upstream commit 785e49c659023df1735bff195ad4ba133ebd23a7).
    - genfio-interpreter: Keep /bin/bash as interpreter, no usrmerge (yet).
  * changelog, rules: Removed trailing white spaces as lintian suggests.
  * compat: Switched debhelper compat level from 9 to 11 as lintian and
    debhelper manpage recommend.
  * control:
    - Switched Vcs URLs from Alioth to Salsa as I migrated the repo.
    - Bumped standards version to 4.1.4. No changes needed.
    - Updated build dependency to debhelper version 11 or later.
    - Added build dependency for libnuma1 for all architectures, except
      armhf and armel, where this library is not available (Closes: #861554,
      also see #893778).
    - Added build dependencies bison and flex to enable arithmetic
      calculations in fio jobs (see #893778, also see fio manpage,
      JOB FILE PARAMETERS).
    - Added build dependency for the fio GlusterFS engine (see #893778).
    - Disable build dependency for libaio for all platforms except Linux,
      to enable build on non-Linux platforms like Hurd (see #893778).
    - Change binary dependency to python2.7 as all the python scripts use
      this version.
  * rules:
    - Enable verbose build to allow tools like blhc to check for
      hardening flags for compiler and linker (see #893778).
    - Enable all hardening build flags, not just bindnow.
  * docs: Removed tools/fio_latency2csv.py, not in upstream source anymore.
  * copyright: Switched copyright format URL to https as Lintian suggests.
  * Implemented all suggestions from sitsofe´s Debian patch comments I
    decided to implement (Closes: #893778).
  * README.Debian: Added a note about fio´s weird usage of units in job
    files and parseable output (Closes: #872321).

 -- Martin Steigerwald <martin.steigerwald@proact.de>  Mon, 09 Apr 2018 13:45:59 +0200
