=== debian/control ===
--- 
+++ 
@@ -2,15 +2,15 @@
 Section: utils
 Priority: optional
 Maintainer: Martin Steigerwald <martin.steigerwald@proact.de>
-Build-Depends: debhelper (>= 9), dpkg-dev (>= 1.16.1~), libaio-dev, zlib1g-dev, librdmacm-dev, libibverbs-dev, librbd-dev, libgtk2.0-dev, libcairo2-dev
-Standards-Version: 4.1.1.0
+Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.16.1~), libaio-dev [linux-any], zlib1g-dev, librdmacm-dev [linux-any], libibverbs-dev [linux-any], librbd-dev [linux-any], libgtk2.0-dev, libcairo2-dev, libnuma-dev [linux-any], flex, bison, glusterfs-common
+Standards-Version: 4.2.0
 Homepage: https://github.com/axboe/fio
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/fio.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/fio.git
+Vcs-Git: https://salsa.debian.org/debian/fio.git
+Vcs-Browser: https://salsa.debian.org/debian/fio
 
 Package: fio
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, python
+Depends: ${shlibs:Depends}, ${misc:Depends}, python2.7
 Suggests: gnuplot, gfio, python-scipy
 Description: flexible I/O tester
  fio is a tool that will spawn a number of threads or processes doing a
@@ -40,4 +40,3 @@
  fio contains the command line version of fio which acts as a backend
  to the GUI frontend. The frontend can talk to a locally or remotely
  running fio server.
-
